Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 5901)
@@ -6,19 +6,20 @@
    !! History :  OPA  ! 1997-07  (G. Madec)  multi dimensional coefficients
    !!   NEMO     1.0  ! 2002-09  (G. Madec)  F90: Free form and module
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   ldf_dyn_init : initialization, namelist read, and parameters control
-   !!   ldf_dyn_c3d   : 3D eddy viscosity coefficient initialization
-   !!   ldf_dyn_c2d   : 2D eddy viscosity coefficient initialization
-   !!   ldf_dyn_c1d   : 1D eddy viscosity coefficient initialization
+   !!            3.7  ! 2014-01  (F. Lemarie, G. Madec)  restructuration/simplification of ahm specification,
+   !!                 !                                  add velocity dependent coefficient and optional read in file
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   ldf_dyn_init  : initialization, namelist read, and parameters control
+   !!   ldf_dyn       : update lateral eddy viscosity coefficients at each time step 
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers   
    USE dom_oce         ! ocean space and time domain 
-   USE ldfdyn_oce      ! ocean dynamics lateral physics
    USE phycst          ! physical constants
-   USE ldfslp          ! ???
-   USE ioipsl
+   USE ldfc1d_c2d      ! lateral diffusion: 1D and 2D cases
+   !
    USE in_out_manager  ! I/O manager
+   USE iom             ! I/O module for ehanced bottom friction file
+   USE timing          ! Timing
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -28,14 +29,31 @@
    PRIVATE
 
-   PUBLIC   ldf_dyn_init   ! called by opa.F90
-
-  INTERFACE ldf_zpf
-     MODULE PROCEDURE ldf_zpf_1d, ldf_zpf_1d_3d, ldf_zpf_3d
-  END INTERFACE
+   PUBLIC   ldf_dyn_init   ! called by nemogcm.F90
+   PUBLIC   ldf_dyn        ! called by step.F90
+
+   !                                                !!* Namelist namdyn_ldf : lateral mixing on momentum *
+   LOGICAL , PUBLIC ::   ln_dynldf_lap   !: laplacian operator
+   LOGICAL , PUBLIC ::   ln_dynldf_blp   !: bilaplacian operator
+   LOGICAL , PUBLIC ::   ln_dynldf_lev   !: iso-level direction
+   LOGICAL , PUBLIC ::   ln_dynldf_hor   !: horizontal (geopotential) direction
+   LOGICAL , PUBLIC ::   ln_dynldf_iso   !: iso-neutral direction
+   INTEGER , PUBLIC ::   nn_ahm_ijk_t    !: choice of time & space variations of the lateral eddy viscosity coef.
+   REAL(wp), PUBLIC ::   rn_ahm_0        !: lateral laplacian eddy viscosity            [m2/s]
+   REAL(wp), PUBLIC ::   rn_ahm_b        !: lateral laplacian background eddy viscosity [m2/s]
+   REAL(wp), PUBLIC ::   rn_bhm_0        !: lateral bilaplacian eddy viscosity          [m4/s]
+
+   LOGICAL , PUBLIC ::   l_ldfdyn_time   !: flag for time variation of the lateral eddy viscosity coef.
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ahmt, ahmf   !: eddy diffusivity coef. at U- and V-points   [m2/s or m4/s]
+
+   REAL(wp) ::   r1_12   = 1._wp / 12._wp    ! =1/12
+   REAL(wp) ::   r1_4    = 0.25_wp           ! =1/4
+   REAL(wp) ::   r1_288  = 1._wp / 288._wp   ! =1/( 12^2 * 2 )
 
    !! * Substitutions
 #  include "domzgr_substitute.h90"
-   !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.7 , NEMO Consortium (2014)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -49,29 +67,27 @@
       !! ** Purpose :   set the horizontal ocean dynamics physics
       !!
-      !! ** Method  :  
-      !!      -  default option : ahm = constant coef. = rn_ahm_0 (namelist)
-      !!      - 'key_dynldf_c1d': ahm = F(depth)                     see ldf_dyn_c1d.h90
-      !!      - 'key_dynldf_c2d': ahm = F(latitude,longitude)        see ldf_dyn_c2d.h90
-      !!      - 'key_dynldf_c3d': ahm = F(latitude,longitude,depth)  see ldf_dyn_c3d.h90
-      !!
-      !!      N.B. User defined include files.  By default, 3d and 2d coef.
-      !!      are set to a constant value given in the namelist and the 1d
-      !!      coefficients are initialized to a hyperbolic tangent vertical
-      !!      profile.
-      !!
-      !! Reference :   Madec, G. and M. Imbard, 1996: Climate Dynamics, 12, 381-388.
-      !!----------------------------------------------------------------------
-      INTEGER ::   ioptio         ! ???
-      INTEGER ::   ios            ! Local : output status for namelist read
-      LOGICAL ::   ll_print = .FALSE.    ! Logical flag for printing viscosity coef.
-      !! 
-      NAMELIST/namdyn_ldf/ ln_dynldf_lap  , ln_dynldf_bilap,                  &
-         &                 ln_dynldf_level, ln_dynldf_hor  , ln_dynldf_iso,   &
-         &                 rn_ahm_0_lap   , rn_ahmb_0      , rn_ahm_0_blp ,   &
-         &                 rn_cmsmag_1    , rn_cmsmag_2    , rn_cmsh,         &
-         &                 rn_ahm_m_lap   , rn_ahm_m_blp
-
-   !!----------------------------------------------------------------------
-
+      !! ** Method  :   the eddy viscosity coef. specification depends on:
+      !!              - the operator:
+      !!             ln_dynldf_lap = T     laplacian operator
+      !!             ln_dynldf_blp = T   bilaplacian operator
+      !!              - the parameter nn_ahm_ijk_t:
+      !!    nn_ahm_ijk_t  =  0 => = constant
+      !!                  = 10 => = F(z) :     = constant with a reduction of 1/4 with depth 
+      !!                  =-20 => = F(i,j)     = shape read in 'eddy_viscosity.nc' file
+      !!                  = 20    = F(i,j)     = F(e1,e2) or F(e1^3,e2^3) (lap or bilap case)
+      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_viscosity.nc'  file
+      !!                  = 30    = F(i,j,k)   = 2D (case 20) + decrease with depth (case 10)
+      !!                  = 31    = F(i,j,k,t) = F(local velocity) (  |u|e  /12   laplacian operator
+      !!                                                           or |u|e^3/12 bilaplacian operator )
+      !!----------------------------------------------------------------------
+      INTEGER  ::   jk                ! dummy loop indices
+      INTEGER  ::   ierr, inum, ios   ! local integer
+      REAL(wp) ::   zah0              ! local scalar
+      !
+      NAMELIST/namdyn_ldf/ ln_dynldf_lap, ln_dynldf_blp,                  &
+         &                 ln_dynldf_lev, ln_dynldf_hor, ln_dynldf_iso,   &
+         &                 nn_ahm_ijk_t , rn_ahm_0, rn_ahm_b, rn_bhm_0
+      !!----------------------------------------------------------------------
+      !
       REWIND( numnam_ref )              ! Namelist namdyn_ldf in reference namelist : Lateral physics
       READ  ( numnam_ref, namdyn_ldf, IOSTAT = ios, ERR = 901)
@@ -88,210 +104,191 @@
          WRITE(numout,*) '~~~~~~~'
          WRITE(numout,*) '   Namelist namdyn_ldf : set lateral mixing parameters'
-         WRITE(numout,*) '      laplacian operator                      ln_dynldf_lap   = ', ln_dynldf_lap
-         WRITE(numout,*) '      bilaplacian operator                    ln_dynldf_bilap = ', ln_dynldf_bilap
-         WRITE(numout,*) '      iso-level                               ln_dynldf_level = ', ln_dynldf_level
-         WRITE(numout,*) '      horizontal (geopotential)               ln_dynldf_hor   = ', ln_dynldf_hor
-         WRITE(numout,*) '      iso-neutral                             ln_dynldf_iso   = ', ln_dynldf_iso
-         WRITE(numout,*) '      horizontal laplacian eddy viscosity     rn_ahm_0_lap    = ', rn_ahm_0_lap
-         WRITE(numout,*) '      background viscosity                    rn_ahmb_0       = ', rn_ahmb_0
-         WRITE(numout,*) '      horizontal bilaplacian eddy viscosity   rn_ahm_0_blp    = ', rn_ahm_0_blp
-         WRITE(numout,*) '      upper limit for laplacian eddy visc     rn_ahm_m_lap    = ', rn_ahm_m_lap
-         WRITE(numout,*) '      upper limit for bilap eddy viscosity    rn_ahm_m_blp    = ', rn_ahm_m_blp
-
-      ENDIF
-
-      ahm0     = rn_ahm_0_lap              ! OLD namelist variables defined from DOCTOR namelist variables
-      ahmb0    = rn_ahmb_0
-      ahm0_blp = rn_ahm_0_blp
-
-      ! ... check of lateral diffusive operator on tracers
-      !           ==> will be done in trazdf module
-
-      ! ... Space variation of eddy coefficients
-      ioptio = 0
-#if defined key_dynldf_c3d
-      IF(lwp) WRITE(numout,*) '   momentum mixing coef. = F( latitude, longitude, depth)'
-      ioptio = ioptio+1
-#endif
-#if defined key_dynldf_c2d
-      IF(lwp) WRITE(numout,*) '   momentum mixing coef. = F( latitude, longitude)'
-      ioptio = ioptio+1
-#endif
-#if defined key_dynldf_c1d
-      IF(lwp) WRITE(numout,*) '   momentum mixing coef. = F( depth )'
-      ioptio = ioptio+1
-      IF( ln_sco ) CALL ctl_stop( 'key_dynldf_c1d cannot be used in s-coordinate (ln_sco)' )
-#endif
-      IF( ioptio == 0 ) THEN
-          IF(lwp) WRITE(numout,*) '   momentum mixing coef. = constant  (default option)'
-        ELSEIF( ioptio > 1 ) THEN
-           CALL ctl_stop( 'use only one of the following keys: key_dynldf_c3d, key_dynldf_c2d, key_dynldf_c1d' )
-      ENDIF
-
-
-      IF( ln_dynldf_bilap ) THEN
-         IF(lwp) WRITE(numout,*) '   biharmonic momentum diffusion'
-         IF( .NOT. ln_dynldf_lap ) ahm0 = ahm0_blp   ! Allow spatially varying coefs, which use ahm0 as input
-         IF( ahm0_blp > 0 .AND. .NOT. lk_esopa )   CALL ctl_stop( 'The horizontal viscosity coef. ahm0 must be negative' )
-      ELSE
-         IF(lwp) WRITE(numout,*) '   harmonic momentum diff. (default)'
-         IF( ahm0 < 0 .AND. .NOT. lk_esopa )   CALL ctl_stop( 'The horizontal viscosity coef. ahm0 must be positive' )
-      ENDIF
-
-
-      ! Lateral eddy viscosity
-      ! ======================
-#if defined key_dynldf_c3d
-      CALL ldf_dyn_c3d( ll_print )   ! ahm = 3D coef. = F( longitude, latitude, depth )
-#elif defined key_dynldf_c2d
-      CALL ldf_dyn_c2d( ll_print )   ! ahm = 1D coef. = F( longitude, latitude )
-#elif defined key_dynldf_c1d
-      CALL ldf_dyn_c1d( ll_print )   ! ahm = 1D coef. = F( depth )
-#else
-                                     ! Constant coefficients
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'inildf: constant eddy viscosity coef. '
-      IF(lwp) WRITE(numout,*) '~~~~~~'
-      IF(lwp) WRITE(numout,*) '        ahm1 = ahm2 = ahm0 =  ',ahm0
-#endif
-     nkahm_smag = 0
-#if defined key_dynldf_smag
-     nkahm_smag = 1
-#endif
-
+         !
+         WRITE(numout,*) '      type :'
+         WRITE(numout,*) '         laplacian operator                   ln_dynldf_lap = ', ln_dynldf_lap
+         WRITE(numout,*) '         bilaplacian operator                 ln_dynldf_blp = ', ln_dynldf_blp
+         !
+         WRITE(numout,*) '      direction of action :'
+         WRITE(numout,*) '         iso-level                            ln_dynldf_lev = ', ln_dynldf_lev
+         WRITE(numout,*) '         horizontal (geopotential)            ln_dynldf_hor = ', ln_dynldf_hor
+         WRITE(numout,*) '         iso-neutral                          ln_dynldf_iso = ', ln_dynldf_iso
+         !
+         WRITE(numout,*) '      coefficients :'
+         WRITE(numout,*) '         type of time-space variation         nn_ahm_ijk_t  = ', nn_ahm_ijk_t
+         WRITE(numout,*) '         lateral laplacian eddy viscosity     rn_ahm_0_lap  = ', rn_ahm_0, ' m2/s'
+         WRITE(numout,*) '         background viscosity (iso case)      rn_ahm_b      = ', rn_ahm_b, ' m2/s'
+         WRITE(numout,*) '         lateral bilaplacian eddy viscosity   rn_ahm_0_blp  = ', rn_bhm_0, ' m4/s'
+      ENDIF
+
+      !                                ! Parameter control
+      IF( .NOT.ln_dynldf_lap .AND. .NOT.ln_dynldf_blp ) THEN
+         IF(lwp) WRITE(numout,*) '   No viscous operator selected. ahmt and ahmf are not allocated'
+         l_ldfdyn_time = .FALSE.
+         RETURN
+      ENDIF
+      !
+      IF( ln_dynldf_blp .AND. ln_dynldf_iso ) THEN     ! iso-neutral bilaplacian not implemented
+         CALL ctl_stop( 'dyn_ldf_init: iso-neutral bilaplacian not coded yet' ) 
+      ENDIF
+
+      ! ... Space/Time variation of eddy coefficients
+      !                                               ! allocate the ahm arrays
+      ALLOCATE( ahmt(jpi,jpj,jpk) , ahmf(jpi,jpj,jpk) , STAT=ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'ldf_dyn_init: failed to allocate arrays')
+      !
+      ahmt(:,:,jpk) = 0._wp                           ! last level always 0  
+      ahmf(:,:,jpk) = 0._wp
+      !
+      !                                               ! value of eddy mixing coef.
+      IF    ( ln_dynldf_lap ) THEN   ;   zah0 =      rn_ahm_0         !   laplacian operator
+      ELSEIF( ln_dynldf_blp ) THEN   ;   zah0 = ABS( rn_bhm_0 )       ! bilaplacian operator
+      ELSE                                                                  ! NO viscous  operator
+         CALL ctl_warn( 'ldf_dyn_init: No lateral viscous operator used ' )
+      ENDIF
+      !
+      l_ldfdyn_time = .FALSE.                         ! no time variation except in case defined below
+      !
+      IF( ln_dynldf_lap .OR. ln_dynldf_blp ) THEN     ! only if a lateral diffusion operator is used
+         !
+         SELECT CASE(  nn_ahm_ijk_t  )                ! Specification of space time variations of ahmt, ahmf
+         !
+         CASE(   0  )      !==  constant  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = constant '
+            ahmt(:,:,:) = zah0 * tmask(:,:,:)
+            ahmf(:,:,:) = zah0 * fmask(:,:,:)
+            !
+         CASE(  10  )      !==  fixed profile  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F( depth )'
+            ahmt(:,:,1) = zah0 * tmask(:,:,1)                      ! constant surface value
+            ahmf(:,:,1) = zah0 * fmask(:,:,1)
+            CALL ldf_c1d( 'DYN', r1_4, ahmt(:,:,1), ahmf(:,:,1), ahmt, ahmf )
+            !
+         CASE ( -20 )      !== fixed horizontal shape read in file  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F(i,j) read in eddy_viscosity.nc file'
+            CALL iom_open( 'eddy_viscosity_2D.nc', inum )
+            CALL iom_get ( inum, jpdom_data, 'ahmt_2d', ahmt(:,:,1) )
+            CALL iom_get ( inum, jpdom_data, 'ahmf_2d', ahmf(:,:,1) )
+            CALL iom_close( inum )
+!!gm Question : info for LAP or BLP case  to take into account the SQRT in the bilaplacian case ???
+!!              do we introduce a scaling by the max value of the array, and then multiply by zah0 ????
+!!              better:  check that the max is <=1  i.e. it is a shape from 0 to 1, not a coef that has physical dimension
+            DO jk = 2, jpkm1
+               ahmt(:,:,jk) = ahmt(:,:,1) * tmask(:,:,jk)
+               ahmf(:,:,jk) = ahmf(:,:,1) * fmask(:,:,jk)
+            END DO
+            !
+         CASE(  20  )      !== fixed horizontal shape  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F( e1, e2 ) or F( e1^3, e2^3 ) (lap. or blp. case)'
+            IF( ln_dynldf_lap )   CALL ldf_c2d( 'DYN', 'LAP', zah0, ahmt, ahmf )    ! surface value proportional to scale factor
+            IF( ln_dynldf_blp )   CALL ldf_c2d( 'DYN', 'BLP', zah0, ahmt, ahmf )    ! surface value proportional to scale factor^3
+            !
+         CASE( -30  )      !== fixed 3D shape read in file  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F(i,j,k) read in eddy_diffusivity_3D.nc file'
+            CALL iom_open( 'eddy_viscosity_3D.nc', inum )
+            CALL iom_get ( inum, jpdom_data, 'ahmt_3d', ahmt )
+            CALL iom_get ( inum, jpdom_data, 'ahmf_3d', ahmf )
+            CALL iom_close( inum )
+!!gm Question : info for LAP or BLP case  to take into account the SQRT in the bilaplacian case ????
+!!              do we introduce a scaling by the max value of the array, and then multiply by zah0 ????
+            DO jk = 1, jpkm1
+               ahmt(:,:,jk) = ahmt(:,:,jk) * tmask(:,:,jk)
+               ahmf(:,:,jk) = ahmf(:,:,jk) * fmask(:,:,jk)
+            END DO
+            !
+         CASE(  30  )       !==  fixed 3D shape  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F( latitude, longitude, depth )'
+            IF( ln_dynldf_lap )   CALL ldf_c2d( 'DYN', 'LAP', zah0, ahmt, ahmf )    ! surface value proportional to scale factor
+            IF( ln_dynldf_blp )   CALL ldf_c2d( 'DYN', 'BLP', zah0, ahmt, ahmf )    ! surface value proportional to scale factor
+            !                                                    ! reduction with depth
+            CALL ldf_c1d( 'DYN', r1_4, ahmt(:,:,1), ahmf(:,:,1), ahmt, ahmf )
+            !
+         CASE(  31  )       !==  time varying 3D field  ==!
+            IF(lwp) WRITE(numout,*) '          momentum mixing coef. = F( latitude, longitude, depth , time )'
+            IF(lwp) WRITE(numout,*) '                                proportional to the velocity : |u|e/12 or |u|e^3/12'
+            !
+            l_ldfdyn_time = .TRUE.     ! will be calculated by call to ldf_dyn routine in step.F90
+            !
+         CASE DEFAULT
+            CALL ctl_stop('ldf_dyn_init: wrong choice for nn_ahm_ijk_t, the type of space-time variation of ahm')
+         END SELECT
+         !
+         IF( ln_dynldf_blp .AND. .NOT. l_ldfdyn_time ) THEN       ! bilapcian and no time variation:
+            ahmt(:,:,:) = SQRT( ahmt(:,:,:) )                     ! take the square root of the coefficient
+            ahmf(:,:,:) = SQRT( ahmf(:,:,:) )
+         ENDIF
+         !
+      ENDIF
       !
    END SUBROUTINE ldf_dyn_init
 
-#if defined key_dynldf_c3d
-#   include "ldfdyn_c3d.h90"
-#elif defined key_dynldf_c2d
-#   include "ldfdyn_c2d.h90"
-#elif defined key_dynldf_c1d
-#   include "ldfdyn_c1d.h90"
-#endif
-
-
-   SUBROUTINE ldf_zpf_1d( ld_print, pdam, pwam, pbot, pdep, pah )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE ldf_zpf  ***
-      !!                   
-      !! ** Purpose :   vertical adimensional profile for eddy coefficient
-      !!
-      !! ** Method  :   1D eddy viscosity coefficients ( depth )
-      !!----------------------------------------------------------------------
-      LOGICAL , INTENT(in   )                 ::   ld_print   ! If true, output arrays on numout
-      REAL(wp), INTENT(in   )                 ::   pdam       ! depth of the inflection point
-      REAL(wp), INTENT(in   )                 ::   pwam       ! width of inflection
-      REAL(wp), INTENT(in   )                 ::   pbot       ! bottom value (0<pbot<= 1)
-      REAL(wp), INTENT(in   ), DIMENSION(jpk) ::   pdep       ! depth of the gridpoint (T, U, V, F)
-      REAL(wp), INTENT(inout), DIMENSION(jpk) ::   pah        ! adimensional vertical profile
-      !!
-      INTEGER  ::   jk           ! dummy loop indices
-      REAL(wp) ::   zm00, zm01, zmhb, zmhs       ! temporary scalars
-      !!----------------------------------------------------------------------
-
-      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )
-      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
-      zmhs = zm00 / zm01
-      zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
-
-      DO jk = 1, jpk
-         pah(jk) = 1.e0 + zmhb * ( zm00 - TANH( ( pdam - pdep(jk) ) / pwam )  )
-      END DO
-
-      IF(lwp .AND. ld_print ) THEN      ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '         ahm profile : '
-         WRITE(numout,*)
-         WRITE(numout,'("  jk      ahm       ","  depth t-level " )')
-         DO jk = 1, jpk
-            WRITE(numout,'(i6,2f12.4,3x,2f12.4)') jk, pah(jk), pdep(jk)
-         END DO
-      ENDIF
-      !
-   END SUBROUTINE ldf_zpf_1d
-
-
-   SUBROUTINE ldf_zpf_1d_3d( ld_print, pdam, pwam, pbot, pdep, pah )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE ldf_zpf  ***
-      !!
-      !! ** Purpose :   vertical adimensional profile for eddy coefficient
-      !!
-      !! ** Method  :   1D eddy viscosity coefficients ( depth )
-      !!----------------------------------------------------------------------
-      LOGICAL , INTENT(in   )                         ::   ld_print   ! If true, output arrays on numout
-      REAL(wp), INTENT(in   )                         ::   pdam       ! depth of the inflection point
-      REAL(wp), INTENT(in   )                         ::   pwam       ! width of inflection
-      REAL(wp), INTENT(in   )                         ::   pbot       ! bottom value (0<pbot<= 1)
-      REAL(wp), INTENT(in   ), DIMENSION          (:) ::   pdep       ! depth of the gridpoint (T, U, V, F)
-      REAL(wp), INTENT(inout), DIMENSION      (:,:,:) ::   pah        ! adimensional vertical profile
-      !!
-      INTEGER  ::   jk           ! dummy loop indices
-      REAL(wp) ::   zm00, zm01, zmhb, zmhs, zcf  ! temporary scalars
-      !!----------------------------------------------------------------------
-
-      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )
-      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
-      zmhs = zm00 / zm01
-      zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
-
-      DO jk = 1, jpk
-         zcf = 1.e0 + zmhb * ( zm00 - TANH( ( pdam - pdep(jk) ) / pwam )  )
-         pah(:,:,jk) = zcf
-      END DO
-
-      IF(lwp .AND. ld_print ) THEN      ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '         ahm profile : '
-         WRITE(numout,*)
-         WRITE(numout,'("  jk      ahm       ","  depth t-level " )')
-         DO jk = 1, jpk
-            WRITE(numout,'(i6,2f12.4,3x,2f12.4)') jk, pah(1,1,jk), pdep(jk)
-         END DO
-      ENDIF
-      !
-   END SUBROUTINE ldf_zpf_1d_3d
-
-
-   SUBROUTINE ldf_zpf_3d( ld_print, pdam, pwam, pbot, pdep, pah )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE ldf_zpf  ***
-      !!
-      !! ** Purpose :   vertical adimensional profile for eddy coefficient
-      !!
-      !! ** Method  :   3D for partial step or s-coordinate
-      !!----------------------------------------------------------------------
-      LOGICAL , INTENT(in   )                         ::   ld_print   ! If true, output arrays on numout
-      REAL(wp), INTENT(in   )                         ::   pdam       ! depth of the inflection point
-      REAL(wp), INTENT(in   )                         ::   pwam       ! width of inflection
-      REAL(wp), INTENT(in   )                         ::   pbot       ! bottom value (0<pbot<= 1)
-      REAL(wp), INTENT(in   ), DIMENSION      (:,:,:) ::   pdep       ! dep of the gridpoint (T, U, V, F)
-      REAL(wp), INTENT(inout), DIMENSION      (:,:,:) ::   pah        ! adimensional vertical profile
-      !!
-      INTEGER  ::   jk           ! dummy loop indices
-      REAL(wp) ::   zm00, zm01, zmhb, zmhs       ! temporary scalars
-      !!----------------------------------------------------------------------
-
-      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )   
-      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
-      zmhs = zm00 / zm01
-      zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
-
-      DO jk = 1, jpk
-         pah(:,:,jk) = 1.e0 + zmhb * ( zm00 - TANH( ( pdam - pdep(:,:,jk) ) / pwam )  )
-      END DO
-
-      IF(lwp .AND. ld_print ) THEN      ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '         ahm profile : '
-         WRITE(numout,*)
-         WRITE(numout,'("  jk      ahm       ","  depth t-level " )')
-         DO jk = 1, jpk
-            WRITE(numout,'(i6,2f12.4,3x,2f12.4)') jk, pah(1,1,jk), pdep(1,1,jk)
-         END DO
-      ENDIF
-      !
-   END SUBROUTINE ldf_zpf_3d
+
+   SUBROUTINE ldf_dyn( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE ldf_dyn  ***
+      !! 
+      !! ** Purpose :   update at kt the momentum lateral mixing coeff. (ahmt and ahmf)
+      !!
+      !! ** Method  :   time varying eddy viscosity coefficients:
+      !!
+      !!    nn_ahm_ijk_t = 31    ahmt, ahmf = F(i,j,k,t) = F(local velocity) 
+      !!                         ( |u|e /12  or  |u|e^3/12 for laplacian or bilaplacian operator )
+      !!                BLP case : sqrt of the eddy coef, since bilaplacian is en re-entrant laplacian
+      !!
+      !! ** action  :    ahmt, ahmf   update at each time step
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! time step index
+      !
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zu2pv2_ij_p1, zu2pv2_ij, zu2pv2_ij_m1, zetmax, zefmax   ! local scalar
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('ldf_dyn')
+      !
+      SELECT CASE(  nn_ahm_ijk_t  )       !== Eddy vicosity coefficients ==!
+      !
+      CASE(  31  )       !==  time varying 3D field  ==!   = F( local velocity )
+         !
+         IF( ln_dynldf_lap   ) THEN          !   laplacian operator : |u| e /12 = |u/144| e
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1
+                     zu2pv2_ij_p1 = ub(ji  ,jj+1,jk) * ub(ji  ,jj+1,jk) + vb(ji+1,jj  ,jk) * vb(ji+1,jj  ,jk)
+                     zu2pv2_ij    = ub(ji  ,jj  ,jk) * ub(ji  ,jj  ,jk) + vb(ji  ,jj  ,jk) * vb(ji  ,jj  ,jk)
+                     zu2pv2_ij_m1 = ub(ji-1,jj  ,jk) * ub(ji-1,jj  ,jk) + vb(ji  ,jj-1,jk) * vb(ji  ,jj-1,jk)
+                     zetmax = MAX( e1t(ji,jj) , e2t(ji,jj) )
+                     zefmax = MAX( e1f(ji,jj) , e2f(ji,jj) )
+                     ahmt(ji,jj,jk) = SQRT( (zu2pv2_ij + zu2pv2_ij_m1) * r1_288 ) * zetmax * tmask(ji,jj,jk)      ! 288= 12*12 * 2
+                     ahmf(ji,jj,jk) = SQRT( (zu2pv2_ij + zu2pv2_ij_p1) * r1_288 ) * zefmax * fmask(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         ELSEIF( ln_dynldf_blp ) THEN      ! bilaplacian operator : sqrt( |u| e^3 /12 ) = sqrt( |u/144| e ) * e
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1
+                     zu2pv2_ij_p1 = ub(ji  ,jj+1,jk) * ub(ji  ,jj+1,jk) + vb(ji+1,jj  ,jk) * vb(ji+1,jj  ,jk)
+                     zu2pv2_ij    = ub(ji  ,jj  ,jk) * ub(ji  ,jj  ,jk) + vb(ji  ,jj  ,jk) * vb(ji  ,jj  ,jk)
+                     zu2pv2_ij_m1 = ub(ji-1,jj  ,jk) * ub(ji-1,jj  ,jk) + vb(ji  ,jj-1,jk) * vb(ji  ,jj-1,jk)
+                     zetmax = MAX( e1t(ji,jj) , e2t(ji,jj) )
+                     zefmax = MAX( e1f(ji,jj) , e2f(ji,jj) )
+                     ahmt(ji,jj,jk) = SQRT(  SQRT( (zu2pv2_ij + zu2pv2_ij_m1) * r1_288 ) * zetmax  ) * zetmax * tmask(ji,jj,jk)
+                     ahmf(ji,jj,jk) = SQRT(  SQRT( (zu2pv2_ij + zu2pv2_ij_p1) * r1_288 ) * zefmax  ) * zefmax * fmask(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         ENDIF
+         !
+         CALL lbc_lnk( ahmt, 'T', 1. )   ;   CALL lbc_lnk( ahmf, 'F', 1. )
+         !
+      END SELECT
+      !
+      CALL iom_put( "ahmt_2d", ahmt(:,:,1) )   ! surface u-eddy diffusivity coeff.
+      CALL iom_put( "ahmf_2d", ahmf(:,:,1) )   ! surface v-eddy diffusivity coeff.
+      CALL iom_put( "ahmt_3d", ahmt(:,:,:) )   ! 3D      u-eddy diffusivity coeff.
+      CALL iom_put( "ahmf_3d", ahmf(:,:,:) )   ! 3D      v-eddy diffusivity coeff.
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('ldf_dyn')
+      !
+   END SUBROUTINE ldf_dyn
 
    !!======================================================================
